package com.adventurer_engine.common;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.adventurer_engine.common.items.blank.ranged_weapon.BasicAmmo;
import com.adventurer_engine.common.items.blank.ranged_weapon.BasicRangedWeapon;
import java.util.Random;
import uf;
import yc;
import ye;

public class PlayerTools {
  public static boolean hasItem(uf player, yc item) {
    ye[] items = player.bn.a;
    for (ye x : items) {
      if (x != null && 
        x.b().equals(item))
        return true; 
    } 
    return false;
  }
  
  public static boolean consumeItem(uf player, yc item) {
    return true;
  }
  
  private static Random ran = new Random();
  
  public static float randomGaussian(float expectation, float variance) {
    if (expectation == 0.0F)
      return 0.0F; 
    if (variance == 0.0F)
      return expectation; 
    return (float)(ran.nextGaussian() * Math.sqrt(variance) + expectation);
  }
  
  public static boolean percent(float p) {
    return (ran.nextFloat() < p);
  }
  
  public static double[] disturbVector(double x, double y, double z, float acc) {
    double[] result = new double[3];
    double magnitude = Math.sqrt(x * x + y * y + z * z);
    result[0] = x + (1.0F - acc) * (ran.nextDouble() - 0.5D) * magnitude;
    result[1] = y + (1.0F - acc) * (ran.nextDouble() - 0.5D) * magnitude;
    result[2] = z + (1.0F - acc) * (ran.nextDouble() - 0.5D) * magnitude;
    return result;
  }
  
  public static boolean consumeAmmo(uf player, String name) {
    if (player.bG.d)
      return true; 
    if ("arrow".equals(name))
      return player.bn.d(yc.n.cv); 
    BasicAmmo am = (BasicAmmo)BasicAmmo.getAmmoByString(name);
    if (am.unbreakable)
      return true; 
    if (am.maxAmmoAmount == 1)
      return player.bn.d(am.cv); 
    int max = -1, max_idx = 0;
    for (int i = 0; i < player.bn.a.length; i++) {
      if (player.bn.a[i] != null && 
        (player.bn.a[i]).d == am.cv && 
        player.bn.a[i].k() > max) {
        max = player.bn.a[i].k();
        max_idx = i;
      } 
    } 
    if (max == -1)
      return false; 
    ye stack = player.bn.a[max_idx];
    if (stack.b > 1) {
      ye newStack = stack.a(1);
      if (newStack.k() + 1 != am.maxAmmoAmount) {
        newStack.a(1, ran);
        player.bn.a(newStack);
      } 
    } else if (stack.k() + 1 == am.maxAmmoAmount) {
      player.bn.a[max_idx] = null;
    } else {
      stack.a(1, ran);
    } 
    return true;
  }
  
  public static int[] ammoAmountList(uf player, BasicRangedWeapon weapon) {
    int[] amounts = new int[weapon.allowed_ammo.size()];
    for (int i = 0; i < weapon.allowed_ammo.size(); i++)
      amounts[i] = ammoAmount(player, (String)weapon.allowed_ammo.get(i)); 
    return amounts;
  }
  
  public static int ammoAmount(uf player, String ammoName) {
    int result = 0;
    if ("arrow".equals(ammoName)) {
      for (ye i : player.bn.a) {
        if (i != null && 
          (i.b()).cv == yc.n.cv)
          result += i.b; 
      } 
    } else {
      BasicAmmo am = (BasicAmmo)BasicAmmo.getAmmoByString(ammoName);
      for (ye i : player.bn.a) {
        if (i != null && am != null && 
          (i.b()).cv == am.cv)
          result += i.b * (am.maxAmmoAmount - i.k()); 
      } 
    } 
    return result;
  }
}
